import { ESTree } from "meriyah";
import { EvaluateContext } from "./context";
import { JSXComponent, JSXElement, JSXFragment, JSXNode, JSXProperties, JSXText } from "../types/node";
export declare const evalExpression: (exp: ESTree.Expression, context: EvaluateContext) => any;
export declare const evalArrayExpression: (exp: ESTree.ArrayExpression, context: EvaluateContext) => Array<any>;
export declare const evalArrayPattern: (exp: ESTree.ArrayPattern, context: EvaluateContext) => any[];
export declare const evalArrowFunctionExpression: (exp: ESTree.ArrowFunctionExpression, context: EvaluateContext) => never;
export declare const evalAssignmentExpression: (exp: ESTree.AssignmentExpression, context: EvaluateContext) => never;
export declare const evalAwaitExpression: (exp: ESTree.AwaitExpression, context: EvaluateContext) => never;
export declare const evalBinaryExpression: (exp: ESTree.BinaryExpression, context: EvaluateContext) => any;
export declare const evalCallExpression: (exp: ESTree.CallExpression, context: EvaluateContext) => never;
export declare const evalChainExpression: (exp: ESTree.ChainExpression, context: EvaluateContext) => never;
export declare const evalClassDeclaration: (exp: ESTree.ClassDeclaration, context: EvaluateContext) => never;
export declare const evalClassExpression: (exp: ESTree.ClassExpression, context: EvaluateContext) => never;
export declare const evalConditionalExpression: (exp: ESTree.ConditionalExpression, context: EvaluateContext) => any;
export declare const evalFunctionExpression: (exp: ESTree.FunctionExpression, context: EvaluateContext) => never;
export declare const evalIdentifier: (exp: ESTree.Identifier, context: EvaluateContext) => any;
export declare const evalImport: (exp: ESTree.Import, context: EvaluateContext) => never;
export declare const evalImportExpression: (exp: ESTree.ImportExpression, context: EvaluateContext) => never;
export declare const evalLiteral: (exp: ESTree.Literal, _context: EvaluateContext) => ESTree.Literal['value'];
export declare const evalLogicalExpression: (exp: ESTree.LogicalExpression, context: EvaluateContext) => any;
export declare const evalMemberExpression: (exp: ESTree.MemberExpression, context: EvaluateContext) => any;
export declare const evalMetaProperty: (exp: ESTree.MetaProperty, context: EvaluateContext) => never;
export declare const evalNewExpression: (exp: ESTree.NewExpression, context: EvaluateContext) => any;
export declare const evalObjectExpression: (exp: ESTree.ObjectExpression, context: EvaluateContext) => Record<any, any>;
export declare const evalObjectPattern: (exp: ESTree.ObjectPattern, context: EvaluateContext) => Record<any, any>;
export declare const evalRestElement: (exp: ESTree.RestElement, context: EvaluateContext) => any;
export declare const evalSequenceExpression: (exp: ESTree.SequenceExpression, context: EvaluateContext) => undefined;
export declare const evalSpreadElement: (exp: ESTree.SpreadElement, context: EvaluateContext) => any;
export declare const evalSuper: (exp: ESTree.Super, context: EvaluateContext) => never;
export declare const evalTaggedTemplateExpression: (exp: ESTree.TaggedTemplateExpression, context: EvaluateContext) => any;
export declare const evalTemplateLiteral: (exp: ESTree.TemplateLiteral, context: EvaluateContext) => string;
export declare const evalThisExpression: (exp: ESTree.ThisExpression, context: EvaluateContext) => never;
export declare const evalUnaryExpression: (exp: ESTree.UnaryExpression, context: EvaluateContext) => number | boolean | undefined;
export declare const evalUpdateExpression: (exp: ESTree.UpdateExpression, context: EvaluateContext) => never;
export declare const evalYieldExpression: (exp: ESTree.YieldExpression, context: EvaluateContext) => never;
export declare const evalMethodDefinition: (exp: ESTree.MethodDefinition, context: EvaluateContext) => never;
export declare const evalProperty: (exp: ESTree.Property, context: EvaluateContext) => any[];
export declare const evalJSXChild: (jsx: ESTree.JSXChild, context: EvaluateContext) => JSXNode;
export declare const evalJSXElement: (jsx: ESTree.JSXElement, context: EvaluateContext) => JSXElement;
export declare const evalJSXEmptyExpression: (_jsx: ESTree.JSXEmptyExpression, _context: EvaluateContext) => JSXNode;
export declare const evalJSXSpreadChild: (jsx: ESTree.JSXSpreadChild, context: EvaluateContext) => JSXFragment | undefined;
export declare const evalJSXExpressionContainer: (jsx: ESTree.JSXExpressionContainer, context: EvaluateContext) => any;
export declare const evalJSXFragment: (jsx: ESTree.JSXFragment, context: EvaluateContext) => JSXFragment;
export declare const evalJSXText: (jsx: ESTree.JSXText, _context: EvaluateContext) => JSXText;
export declare const evalJSXClosingElement: (_jsx: ESTree.JSXClosingElement, context: EvaluateContext) => undefined;
export declare const evalJSXClosingFragment: (_jsx: ESTree.JSXClosingFragment, context: EvaluateContext) => undefined;
export declare const evalJSXOpeningElement: (jsx: ESTree.JSXOpeningElement, context: EvaluateContext) => [JSXComponent, JSXProperties];
export declare const evalJSXOpeningFragment: (_jsx: ESTree.JSXOpeningFragment, context: EvaluateContext) => [undefined, JSXProperties];
export declare const evalJSXTagNameExpression: (jsx: ESTree.JSXTagNameExpression, context: EvaluateContext) => string;
export declare const evalJSXIdentifier: (jsx: ESTree.JSXIdentifier, _context: EvaluateContext) => string;
export declare const evalJSXMemberExpression: (jsx: ESTree.JSXMemberExpression, context: EvaluateContext) => string;
export declare const evalJSXNamespacedName: (jsx: ESTree.JSXNamespacedName, context: EvaluateContext) => string;
export declare const evalJSXAttribute: (jsx: ESTree.JSXAttribute, context: EvaluateContext) => [string, any];
export declare const evalJSXSpreadAttribute: (jsx: ESTree.JSXSpreadAttribute, context: EvaluateContext) => any;
export declare const evalJSXAttributeValue: (jsx: ESTree.JSXAttributeValue, context: EvaluateContext) => any;
//# sourceMappingURL=expression.d.ts.map