import { ESTree } from 'meriyah';
import { EvaluateContext } from './context';
export interface IdentifierBinding {
    type: 'Identifier';
    name: string;
    default?: any;
}
export interface PathBinding {
    [key: string]: Binding;
}
export interface ObjectBinding {
    type: 'Object';
    binds: PathBinding;
    rest: IdentifierBinding | null;
    default?: any;
}
export interface ArrayBinding {
    type: 'Array';
    binds: (Binding | null)[];
    rest: IdentifierBinding | null;
    default?: any;
}
export declare type Binding = IdentifierBinding | ObjectBinding | ArrayBinding;
export declare const evalBindingPattern: (bind: ESTree.BindingPattern | ESTree.AssignmentPattern | ESTree.Expression, context: EvaluateContext) => Binding;
export declare const setBinding: (bind: Binding, val: any, context: EvaluateContext, define?: "var" | "let" | "const" | undefined) => any;
//# sourceMappingURL=bind.d.ts.map