import { ESTree } from 'meriyah';
import { Binding, ComponentsBinding } from '../types/binding';
import { EvaluateOptions } from './options';
declare class KeyGenerator {
    private readonly prefix;
    private readonly counter;
    constructor(prefix?: string);
    increment(): void;
    openingElement(): void;
    closingElement(): void;
    generate(): string;
}
declare type VariableKind = ESTree.VariableDeclaration['kind'];
declare class Variable {
    readonly kind: VariableKind;
    private init;
    private stored;
    constructor(kind: VariableKind);
    get value(): any;
    set value(val: any);
}
declare class Stack {
    readonly self: any;
    private variables;
    constructor(self: any, init?: Record<string, any>);
    has(name: string): boolean;
    get(name: string): any;
    define(kind: VariableKind, name: string): void;
    set(name: string, value: any): void;
}
export declare class EvaluateContext {
    readonly options: EvaluateOptions;
    readonly keyGenerator: KeyGenerator;
    readonly binding: Binding;
    readonly components: ComponentsBinding;
    readonly stacks: Stack[];
    readonly exports: Record<string, any>;
    constructor(options: EvaluateOptions);
    get stack(): Stack | undefined;
    pushStack(self: any): void;
    popStack(): void;
    defineVariable(kind: VariableKind, name: string): void;
    setVariable(name: string, value: any): void;
    resolveThis(): any;
    resolveIdentifier(name: string): Variable;
    resolveComponent(name: string): any;
    export(name: string, value: any): void;
    private _label;
    get label(): string | undefined;
    set label(l: string | undefined);
}
export {};
//# sourceMappingURL=context.d.ts.map