import { ESTree } from 'meriyah';
import { EvaluateContext } from './context';
export declare class EvaluateError extends Error {
    readonly node: ESTree.Node;
    readonly context: EvaluateContext;
    constructor(message: string, node: ESTree.Node, context: EvaluateContext);
}
export declare class JSXBreak extends Error {
    readonly label: string | undefined;
    constructor(label?: string);
    get isLabeled(): boolean;
}
export declare class JSXContinue extends Error {
    readonly label: string | undefined;
    constructor(label?: string);
    get isLabeled(): boolean;
}
export declare class JSXReturn extends Error {
    readonly value: any;
    constructor(value: any);
}
//# sourceMappingURL=error.d.ts.map