import { ESTree } from 'meriyah';
import { Binding, IdentifierBinding } from './bind';
import { EvaluateContext } from './context';
export declare const evalStatement: (stmt: ESTree.Statement, context: EvaluateContext) => any;
export declare const evalBlockStatement: (stmt: ESTree.BlockStatement, context: EvaluateContext) => void;
export declare const evalBreakStatement: (stmt: ESTree.BreakStatement, __: EvaluateContext) => never;
export declare const evalContinueStatement: (stmt: ESTree.ContinueStatement, __: EvaluateContext) => never;
export declare const evalDebuggerStatement: (_: ESTree.DebuggerStatement, __: EvaluateContext) => void;
export declare const evalDoWhileStatement: (stmt: ESTree.DoWhileStatement, context: EvaluateContext) => void;
export declare const evalEmptyStatement: (_: ESTree.EmptyStatement, __: EvaluateContext) => void;
export declare const evalExportAllDeclaration: (stmt: ESTree.ExportAllDeclaration, context: EvaluateContext) => never;
export declare const evalExportDefaultDeclaration: (stmt: ESTree.ExportDefaultDeclaration, context: EvaluateContext) => void;
export declare const evalExportNamedDeclaration: (stmt: ESTree.ExportNamedDeclaration, context: EvaluateContext) => any;
export declare const evalExpressionStatement: (stmt: ESTree.ExpressionStatement, context: EvaluateContext) => void;
export declare const evalForInStatement: (stmt: ESTree.ForInStatement, context: EvaluateContext) => void;
export declare const evalForOfStatement: (stmt: ESTree.ForOfStatement, context: EvaluateContext) => void;
export declare const evalForStatement: (stmt: ESTree.ForStatement, context: EvaluateContext) => void;
export declare const evalFunctionDeclaration: (stmt: ESTree.FunctionDeclaration, context: EvaluateContext) => (IdentifierBinding | ((...args: any[]) => any) | undefined)[];
export declare const evalIfStatement: (stmt: ESTree.IfStatement, context: EvaluateContext) => void;
export declare const evalImportDeclaration: (stmt: ESTree.ImportDeclaration, context: EvaluateContext) => never;
export declare const evalLabeledStatement: (stmt: ESTree.LabeledStatement, context: EvaluateContext) => void;
export declare const evalReturnStatement: (stmt: ESTree.ReturnStatement, context: EvaluateContext) => never;
export declare const evalSwitchStatement: (stmt: ESTree.SwitchStatement, context: EvaluateContext) => void;
export declare const evalThrowStatement: (stmt: ESTree.ThrowStatement, context: EvaluateContext) => never;
export declare const evalTryStatement: (stmt: ESTree.TryStatement, context: EvaluateContext) => void;
export declare const evalVariableDeclaration: (stmt: ESTree.VariableDeclaration, context: EvaluateContext) => Binding[];
export declare const evalWhileStatement: (stmt: ESTree.WhileStatement, context: EvaluateContext) => void;
export declare const evalWithStatement: (stmt: ESTree.WithStatement, context: EvaluateContext) => never;
//# sourceMappingURL=statement.d.ts.map