import * as Acorn from 'acorn';
import { ComponentType, ExoticComponent } from 'react';
declare type Component = string | ComponentType | ExoticComponent;
interface Components {
    [key: string]: Component | Components;
}
interface Binding {
    [key: string]: any;
}
declare type Properties = Record<string, any>;
export declare type JSXElement = {
    component: Component;
    props: Properties;
    children: JSXElement[];
};
export declare type JSXFilter = (element: JSXElement) => JSXElement | undefined;
export interface JSXEvaluatorOption {
    binding: Binding;
    components: Components;
    filters: JSXFilter[];
}
export declare class JSXEvaluator {
    private parser;
    private binding;
    private components;
    private filters;
    private elementCounter;
    constructor(option: JSXEvaluatorOption);
    parse(jsx: string): Acorn.Node;
    eval(jsx: string): JSXElement[];
    private evalExpression;
    private evalIdentifier;
    private evalUnary;
    private evalBinary;
    private evalCall;
    private evalMember;
    private evalObject;
    private evalJSXElement;
    private evalElementName;
    private resolveComponent;
    private generateKey;
}
export {};
//# sourceMappingURL=evaluator.d.ts.map